/**
 * Entry point of menubar
 * @example
 * ```typescript
 * import { menubar } from 'menubar';
 * ```
 */
import { Menubar } from './Menubar';
import { Options } from './types';
export * from './util/getWindowPosition';
export { Menubar };
/**
 * Factory function to create a menubar application
 *
 * @param options - Options for creating a menubar application, see
 * {@link Options}
 */
export declare function menubar(options?: Partial<Options>): Menubar;
