require('dotenv').config()
const { notarize } = require('electron-notarize')
const path = require('path')
const pkg = require('./../package.json')

module.exports = function (context) {
  if (process.platform !== 'darwin') {
    console.log('Not a Mac skipping notarization')
    return
  }

  console.log('Notarizing...')

  const appName = pkg.productName
  const appOutDir = path.join(process.cwd(), `./out/${appName}-darwin-x64`)

  console.log({appOutDir})

  return notarize({
    appBundleId: 'com.iconscout.app',
    appPath: `${appOutDir}/${appName}.app`,
    appleId: process.env.APPLE_ID,
    appleIdPassword: process.env.APPLE_ID_PASS
  }).catch((e) => {
    console.error(e)
    throw e
  })
}
