const { ipcMain } = require('electron')
const AutoLaunch = require('auto-launch')
const pkg = require('../package.json')

const autoLauncher = new AutoLaunch({
  name: pkg.productName
})

autoLauncher.enable()

ipcMain.on('fetchAutoLaunch', async (event) => {
  event.reply('settings', {
    autolaunch: await autoLauncher.isEnabled()
  })
})

ipcMain.on('setAutoLaunch', async (event, value) => {
  if (value) {
    autoLauncher.enable()
  } else {
    autoLauncher.disable()
  }
})
