const fs = require('fs')

const request = require('request')

module.exports = async function (url, dest) {
  return new Promise((resolve, reject) => {
    if (fs.existsSync(dest)) {
      resolve(dest)
    } else {
      const file = fs.createWriteStream(dest)
      request
        .get(url)
        .pipe(file)
        .on('finish', function () {
          resolve(file)
        })
        .on('error', (err) => {
          // Handle errors
          fs.unlink(dest) // Delete the file async. (But we don't check the result)
          reject(err.message)
        })
    }
  })
}
