const path = require('path')

const md5 = require('md5')
const URL = require('url')

module.exports = function (url) {
  let ext = ''
  let brandPaletteId = ''
  let query = URL.parse(url, true).query

  if (query.format) {
    ext = `.${query.format}`
  }

  if (query.brand_palette_id) {
    brandPaletteId = query.brand_palette_id
  }

  if (query.url) {
    url = query.url
  }

  query = URL.parse(url, true).query

  if (query.url) {
    url = query.url
  }

  const pathname = URL.parse(url, true).pathname
  const filename = path.basename(pathname)

  if (!ext) {
    ext = path.extname(filename)
  }

  if (brandPaletteId) {
    return md5(`${pathname}-${brandPaletteId}`) + ext
  } else {
    return md5(pathname) + ext
  }
}
