const path = require('path')
const fs = require('fs')

module.exports = async function(dir, oldName, newName) {
  return new Promise((resolve, reject) => {
    const dest = path.join(dir, newName)
    const source = path.join(dir, oldName)

    if (fs.existsSync(dest)) {
      fs.unlinkSync(dest)
    }

    fs.renameSync(source, dest)

    resolve(dest)
  })
}
